# Based on code generated by ScriptoMatic from MicroSoft.

# Perl script to collect general data.
# Copyright (C) 2006-2009 QNH.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Contact information: scc.qnh-infrastructure.nl

# SCC-release:	1.1.5
# file-version:	$Revision: 1.19 $

my $PROGNAME = "$0";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "start $PROGNAME \n";
}
use strict;

# Indicate the layout-version. This enables us to check for a new release.
# The exact contents of this string is used in scc-log.pl
print "fix:general::layout-version:1.1.5\n";

use Win32::OLE('in');

use constant wbemFlagReturnImmediately => 0x10;
use constant wbemFlagForwardOnly => 0x20;

my $computer = $ENV{ SCC_WMI_COMPUTER };

my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2") or die "$PROGNAME: WMI connection failed.\n";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_OperatingSystem\n";
}
my $OS_colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_OperatingSystem", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);
print "hlp:general::Data from class Win32_OperatingSystem\n";
foreach my $objItem (in $OS_colItems)
{
	print "fix:general::hostname:$objItem->{CSName}\n";
	my $OS = $objItem->{Caption};
	$OS =~ s/.*\(R\) //;			# Erase all trademarks from the name.
	print "fix:general::OS-name:$OS\n";
	print "fix:general::BuildNumber:$objItem->{BuildNumber}\n";
	print "fix:general::BuildType:$objItem->{BuildType}\n";
	print "fix:general::Version:$objItem->{Version}\n";
	print "fix:general::ServicePackMajorVersion:$objItem->{ServicePackMajorVersion}\n";
	print "fix:general::ServicePackMinorVersion:$objItem->{ServicePackMinorVersion}\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_ComputerSystem\n";
}
my $CS_colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_ComputerSystem", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);
print "hlp:general::Data from class Win32_ComputerSystem\n";
foreach my $objItem (in $CS_colItems)
{
	# Remove CR/LF from model.
	my $model = "$objItem->{Model}";
	$model =~ s/\012/_/g;
	$model =~ s/\015/_/g;
	print "fix:general::model:$model\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_OperatingSystem\n";
}
my $OS_colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_OperatingSystem", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);
foreach my $objItem (in $OS_colItems)
{
	print "fix:general::BootDevice:$objItem->{BootDevice}\n";
	print "fix:general::CodeSet:$objItem->{CodeSet}\n";
	print "fix:general::CountryCode:$objItem->{CountryCode}\n";
	print "fix:general::CSDVersion:$objItem->{CSDVersion}\n";
	print "fix:general::EncryptionLevel:$objItem->{EncryptionLevel}\n";
	print "var:general::FreePhysicalMemory:$objItem->{FreePhysicalMemory}\n";
	print "var:general::FreeSpaceInPagingFiles:$objItem->{FreeSpaceInPagingFiles}\n";
	print "var:general::FreeVirtualMemory:$objItem->{FreeVirtualMemory}\n";
	print "var:general::InstallDate:$objItem->{InstallDate}\n";
	print "var:general::LastBootUpTime:$objItem->{LastBootUpTime}\n";
	print "var:general::LocalDateTime:$objItem->{LocalDateTime}\n";
	print "fix:general::Locale:$objItem->{Locale}\n";
	print "fix:general::Manufacturer:$objItem->{Manufacturer}\n";
	print "fix:general::MaxNumberOfProcesses:$objItem->{MaxNumberOfProcesses}\n";
	print "fix:general::Name:$objItem->{Name}\n";
	print "fix:general::Organization:$objItem->{Organization}\n";
	print "fix:general::OSLanguage:$objItem->{OSLanguage}\n";
	print "fix:general::OSProductSuite:$objItem->{OSProductSuite}\n";
	print "fix:general::OSType:$objItem->{OSType}\n";
	print "fix:general::OtherTypeDescription:$objItem->{OtherTypeDescription}\n";
	print "fix:general::RegisteredUser:$objItem->{RegisteredUser}\n";
	print "fix:general::SerialNumber:$objItem->{SerialNumber}\n";
	print "fix:general::SystemDevice:$objItem->{SystemDevice}\n";
	print "fix:general::SystemDirectory:$objItem->{SystemDirectory}\n";
	print "fix:general::SystemDrive:$objItem->{SystemDrive}\n";
	print "var:general::TotalSwapSpaceSize:$objItem->{TotalSwapSpaceSize}\n";
	print "var:general::TotalVirtualMemorySize:$objItem->{TotalVirtualMemorySize}\n";
	print "var:general::TotalVisibleMemorySize:$objItem->{TotalVisibleMemorySize}\n";

	print "fix:general::WindowsDirectory:$objItem->{WindowsDirectory}\n";
}

my %role_list = ();
$role_list{ 0 } = "Standalone Workstation";
$role_list{ 1 } = "Member Workstation";
$role_list{ 2 } = "Standalone Server";
$role_list{ 3 } = "Member Server";
$role_list{ 4 } = "Backup Domain Controller";
$role_list{ 5 } = "Primary Domain Controller";

my %admin_pw_status_list = ();
$admin_pw_status_list{ 0 } = "Disabled";
$admin_pw_status_list{ 1 } = "Enabled";
$admin_pw_status_list{ 2 } = "Not Implemented";
$admin_pw_status_list{ 3 } = "Unknown";

my %wake_up_type_list = ();
$wake_up_type_list{ 0 } = "Reserved";
$wake_up_type_list{ 1 } = "Other";
$wake_up_type_list{ 2 } = "Unknown";
$wake_up_type_list{ 3 } = "APM Timer";
$wake_up_type_list{ 4 } = "Modem Ring";
$wake_up_type_list{ 5 } = "LAN Remote";
$wake_up_type_list{ 6 } = "Power Switch";
$wake_up_type_list{ 7 } = "PCI PME#";
$wake_up_type_list{ 8 } = "AC Power Restored";

my %thermal_state_list = ();
$thermal_state_list{ 1 } = "Other";
$thermal_state_list{ 2 } = "Unknown";
$thermal_state_list{ 3 } = "Safe";
$thermal_state_list{ 4 } = "Warning";
$thermal_state_list{ 5 } = "Critical";
$thermal_state_list{ 6 } = "Non-recoverable";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_ComputerSystem\n";
}
my $CS_colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_ComputerSystem", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);
foreach my $objItem (in $CS_colItems)
{
	print "fix:general::AdminPasswordStatus:$admin_pw_status_list{ $objItem->{AdminPasswordStatus} }\n";
	print "fix:general::AutomaticResetBootOption:$objItem->{AutomaticResetBootOption}\n";
	print "fix:general::AutomaticResetCapability:$objItem->{AutomaticResetCapability}\n";
	print "fix:general::CurrentTimeZone:$objItem->{CurrentTimeZone}\n";
	print "fix:general::DaylightInEffect:$objItem->{DaylightInEffect}\n";
	print "fix:general::Description:$objItem->{Description}\n";
	print "fix:general::Domain:$objItem->{Domain}\n";
	print "fix:general::DomainRole:$role_list{ $objItem->{DomainRole} }\n";
	print "fix:general::EnableDaylightSavingsTime:$objItem->{EnableDaylightSavingsTime}\n";
	print "fix:general::FrontPanelResetStatus:$objItem->{FrontPanelResetStatus}\n";
	print "fix:general::InfraredSupported:$objItem->{InfraredSupported}\n";
	print "var:general::InstallDate:$objItem->{InstallDate}\n";
	print "fix:general::KeyboardPasswordStatus:$objItem->{KeyboardPasswordStatus}\n";
	print "fix:general::Manufacturer:$objItem->{Manufacturer}\n";
	print "fix:general::NumberOfProcessors:$objItem->{NumberOfProcessors}\n";
	print "fix:general::PauseAfterReset:$objItem->{PauseAfterReset}\n";
	print "fix:general::PrimaryOwnerName:$objItem->{PrimaryOwnerName}\n";
	print "var:general::Status:$objItem->{Status}\n";
	print "fix:general::SystemType:$objItem->{SystemType}\n";
	print "var:general::ThermalState:$thermal_state_list{ $objItem->{ThermalState}}\n";
# Not accurate, instead the hardware module determines and prints the amount of memory.
#	print "fix:general::TotalPhysicalMemory:$objItem->{TotalPhysicalMemory}\n";
	print "var:general::UserName:$objItem->{UserName}\n";
	# WakeUpType can change from PowerSwitch to APMtimer: tag as variable.
	print "var:general::WakeUpType:$wake_up_type_list{ $objItem->{WakeUpType} }\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "end $PROGNAME \n";
}

exit( 0 );
