# Based on code generated by ScriptoMatic from MicroSoft.

# Perl script to collect boot-data.
# Copyright (C) 2006-2009 QNH.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Contact information: scc.qnh-infrastructure.nl

# SCC-release:	1.1.5
# file-version:	$Revision: 1.15 $

my $PROGNAME = "$0";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "start $PROGNAME \n";
}

use strict;
use Win32::OLE('in');

use constant wbemFlagReturnImmediately => 0x10;
use constant wbemFlagForwardOnly => 0x20;

my $computer = $ENV{ SCC_WMI_COMPUTER };

my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2") or die "$PROGNAME: WMI connection failed.\n";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_BIOS\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_BIOS", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);

my %bios_detail = ();
$bios_detail{ 0 }	= "Reserved";
$bios_detail{ 1 }	= "Reserved";
$bios_detail{ 2 }	= "Unknown";
$bios_detail{ 3 }	= "BIOS Characteristics Not Supported";
$bios_detail{ 4 }	= "ISA is supported";
$bios_detail{ 5 }	= "MCA is supported";
$bios_detail{ 6 }	= "EISA is supported";
$bios_detail{ 7 }	= "PCI is supported";
$bios_detail{ 8 }	= "PC Card (PCMCIA) is supported";
$bios_detail{ 9 }	= "Plug and Play is supported";
$bios_detail{ 10 }	= "APM is supported";
$bios_detail{ 11 }	= "BIOS is Upgradable (Flash)";
$bios_detail{ 12 }	= "BIOS shadowing is allowed";
$bios_detail{ 13 }	= "VL-VESA is supported";
$bios_detail{ 14 }	= "ESCD support is available";
$bios_detail{ 15 }	= "Boot from CD is supported";
$bios_detail{ 16 }	= "Selectable Boot is supported";
$bios_detail{ 17 }	= "BIOS ROM is socketed";
$bios_detail{ 18 }	= "Boot From PC Card (PCMCIA) is supported";
$bios_detail{ 19 }	= "EDD (Enhanced Disk Drive) Specification is supported";
$bios_detail{ 20 }	= "Int 13h - Japanese Floppy for NEC 9800 1.2mb (3.5, 1k Bytes/Sector, 360 RPM) is supported";
$bios_detail{ 21 }	= "Int 13h - Japanese Floppy for Toshiba 1.2mb (3.5, 360 RPM) is supported";
$bios_detail{ 22 }	= "Int 13h - 5.25 / 360 KB Floppy Services are supported";
$bios_detail{ 23 }	= "Int 13h - 5.25 /1.2MB Floppy Services are supported";
$bios_detail{ 24 }	= "Int 13h - 3.5 / 720 KB Floppy Services are supported";
$bios_detail{ 25 }	= "Int 13h - 3.5 / 2.88 MB Floppy Services are supported";
$bios_detail{ 26 }	= "Int 5h, Print Screen Service is supported";
$bios_detail{ 27 }	= "Int 9h, 8042 Keyboard services are supported";
$bios_detail{ 28 }	= "Int 14h, Serial Services are supported";
$bios_detail{ 29 }	= "Int 17h, printer services are supported";
$bios_detail{ 30 }	= "Int 10h, CGA/Mono Video Services are supported";
$bios_detail{ 31 }	= "NEC PC-98";
$bios_detail{ 32 }	= "ACPI supported";
$bios_detail{ 33 }	= "USB Legacy is supported";
$bios_detail{ 34 }	= "AGP is supported";
$bios_detail{ 35 }	= "I2O boot is supported";
$bios_detail{ 36 }	= "LS-120 boot is supported";
$bios_detail{ 37 }	= "ATAPI ZIP Drive boot is supported";
$bios_detail{ 38 }	= "1394 boot is supported";
$bios_detail{ 39 }	= "Smart Battery supported";

print "hlp:boot:BIOS::Data from class Win32_BIOS\n";
foreach my $objItem (in $colItems)
{
	#	1	2	3	4	5	6
	print  "fix:boot:BIOS::BIOSVersion		: " . join(",", (in $objItem->{BIOSVersion})) . "\n";
	foreach my $detail (in $objItem->{BiosCharacteristics})
	{
		if ( $bios_detail{ $detail } )
		{
			print  "fix:boot:BIOS::BiosCharacteristics	: $bios_detail{ $detail }\n";
		}
		else
		{
			if ( $detail >= 40 && $detail <= 47 )
			{
				print  "fix:boot:BIOS::BiosCharacteristics	: $detail: Reserved for BIOS vendor\n";
			}
			elsif ( $detail >= 48 && $detail <= 63 )
			{
				print  "fix:boot:BIOS::BiosCharacteristics	: $detail: Reserved for system vendor\n";
			}
			else
			{
				print  "fix:boot:BIOS::BiosCharacteristics	: $detail: Unknown\n";
			}
		}
	}
	print  "fix:boot:BIOS::BuildNumber		: $objItem->{BuildNumber}\n";
	print  "fix:boot:BIOS::Caption			: $objItem->{Caption}\n";
	print  "fix:boot:BIOS::CodeSet			: $objItem->{CodeSet}\n";
	print  "fix:boot:BIOS::CurrentLanguage		: $objItem->{CurrentLanguage}\n";
	print  "fix:boot:BIOS::Description		: $objItem->{Description}\n";
	print  "fix:boot:BIOS::IdentificationCode	: $objItem->{IdentificationCode}\n";
	print  "fix:boot:BIOS::InstallableLanguages	: $objItem->{InstallableLanguages}\n";
	print  "fix:boot:BIOS::InstallDate		: $objItem->{InstallDate}\n";
	print  "fix:boot:BIOS::LanguageEdition		: $objItem->{LanguageEdition}\n";
	print  "fix:boot:BIOS::ListOfLanguages		: " . join(",", (in $objItem->{ListOfLanguages})) . "\n";
	print  "fix:boot:BIOS::Manufacturer		: $objItem->{Manufacturer}\n";
	print  "fix:boot:BIOS::Name			: $objItem->{Name}\n";
	print  "fix:boot:BIOS::OtherTargetOS		: $objItem->{OtherTargetOS}\n";
	print  "fix:boot:BIOS::PrimaryBIOS		: $objItem->{PrimaryBIOS}\n";
	print  "fix:boot:BIOS::ReleaseDate		: $objItem->{ReleaseDate}\n";
	print  "fix:boot:BIOS::SerialNumber		: $objItem->{SerialNumber}\n";
	print  "fix:boot:BIOS::SMBIOSBIOSVersion	: $objItem->{SMBIOSBIOSVersion}\n";
	print  "fix:boot:BIOS::SMBIOSMajorVersion	: $objItem->{SMBIOSMajorVersion}\n";
	print  "fix:boot:BIOS::SMBIOSMinorVersion	: $objItem->{SMBIOSMinorVersion}\n";
	print  "fix:boot:BIOS::SMBIOSPresent		: $objItem->{SMBIOSPresent}\n";
	print  "fix:boot:BIOS::SoftwareElementID	: $objItem->{SoftwareElementID}\n";
	print  "fix:boot:BIOS::SoftwareElementState	: $objItem->{SoftwareElementState}\n";
	print  "fix:boot:BIOS::Status			: $objItem->{Status}\n";
	print  "fix:boot:BIOS::TargetOperatingSystem	: $objItem->{TargetOperatingSystem}\n";
	print  "fix:boot:BIOS::Version			: $objItem->{Version}\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_ComputerSystem\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_ComputerSystem", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);

print "hlp:boot:BIOS::Data from class Win32_ComputerSystem\n";
foreach my $objItem (in $colItems)
{
	#	1	2	3	4	5	6
	print  "fix:boot:general::BootROMSupported	: $objItem->{BootROMSupported}\n";
	print  "fix:boot:general::BootupState		: $objItem->{BootupState}\n";
	print  "fix:boot:general::ChassisBootupState	: $objItem->{ChassisBootupState}\n";
	print  "fix:boot:general::SystemStartupDelay	: $objItem->{SystemStartupDelay}\n";
	print  "fix:boot:general::SystemStartupOptions	: " . join(",", (in $objItem->{SystemStartupOptions})) . "\n";
	print  "fix:boot:general::SystemStartupSetting	: $objItem->{SystemStartupSetting}\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "end $PROGNAME \n";
}

exit( 0 );
