# Based on code generated by ScriptoMatic from MicroSoft.

# Perl script to collect network data.
# Copyright (C) 2006-2009 QNH.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Contact information: scc.qnh-infrastructure.nl

# SCC-release:	1.1.5
# file-version:	$Revision: 1.20 $

my $PROGNAME = "$0";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "start $PROGNAME \n";
}

use strict;

use Win32::OLE('in');

use constant wbemFlagReturnImmediately => 0x10;
use constant wbemFlagForwardOnly => 0x20;

my $computer = $ENV{ SCC_WMI_COMPUTER };

my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2") or die "$PROGNAME: WMI connection failed.\n";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_ComputerSystem\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_ComputerSystem", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);

print "hlp:network:general::Data from class Win32_ComputerSystem\n";
foreach my $objItem (in $colItems)
{
	print     "fix:network:general::NetworkServerModeEnabled	: $objItem->{NetworkServerModeEnabled}\n";
	print     "fix:network:general::PartOfDomain			: $objItem->{PartOfDomain}\n";
	# The contents of Roles appears to vary.
	print     "var:network:general::Roles				: " . join(",", (in $objItem->{Roles})) . "\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_NetworkAdapterConfiguration\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_NetworkAdapterConfiguration", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);

my $lan_index = 1;
foreach my $objItem (in $colItems)
{
	if ( "$objItem->{IPEnabled}" ne 1 )
	{
		next;
	}

	my $IP = join(",", (in $objItem->{IPAddress}));
	if ( "$IP" eq "0.0.0.0" )
	{
		next;
	}
	
	my $fix_label = "fix:network:lan $lan_index" . "::";
	my $var_label = "var:network:lan $lan_index" . "::";

	print "hlp:network:lan $lan_index" . "::Data from class Win32_NetworkAdapterConfiguration\n";

	if ( "$objItem->{DHCPEnabled}" eq "1" )
	{
		$fix_label = $var_label;
	}

	print $fix_label .     "IPAddress(es)			: $IP\n";
	print $fix_label .     "IPSubnet			: " . join(",", (in $objItem->{IPSubnet})) . "\n";
	print $fix_label .     "MACAddress			: $objItem->{MACAddress}\n";

	print $fix_label .     "DNSDomain			: $objItem->{DNSDomain}\n";
	print $fix_label .     "DNSDomainSuffixSearchOrder	: " . join(",", (in $objItem->{DNSDomainSuffixSearchOrder})) . "\n";
	print $fix_label .     "DNSServerSearchOrder		: " . join(",", (in $objItem->{DNSServerSearchOrder})) . "\n";
	print $fix_label .     "DNSEnabledForWINSResolution	: $objItem->{DNSEnabledForWINSResolution}\n";
	print $fix_label .     "DomainDNSRegistrationEnabled	: $objItem->{DomainDNSRegistrationEnabled}\n";

	print $fix_label .     "WINSEnableLMHostsLookup		: $objItem->{WINSEnableLMHostsLookup}\n";
	if ( "$objItem->{WINSEnableLMHostsLookup}" eq "1" )
	{
		print $fix_label .     "WINSHostLookupFile		: $objItem->{WINSHostLookupFile}\n";
		print $fix_label .     "WINSScopeID			: $objItem->{WINSScopeID}\n";
		print $fix_label .     "WINSPrimaryServer		: $objItem->{WINSPrimaryServer}\n";
		print $fix_label .     "WINSSecondaryServer		: $objItem->{WINSSecondaryServer}\n";
	}

	print $fix_label .     "DHCPEnabled			: $objItem->{DHCPEnabled}\n";
	if ( "$objItem->{DHCPEnabled}" eq "1" )
	{
		print $fix_label .     "DHCPServer			: $objItem->{DHCPServer}\n";
		print $var_label .     "DHCPLeaseExpires		: $objItem->{DHCPLeaseExpires}\n";
		print $var_label .     "DHCPLeaseObtained		: $objItem->{DHCPLeaseObtained}\n";
	}

	print $fix_label .     "DatabasePath			: $objItem->{DatabasePath}\n";
	print $fix_label .     "DefaultIPGateway		: " . join(",", (in $objItem->{DefaultIPGateway})) . "\n";
	print $fix_label .     "DefaultTOS			: $objItem->{DefaultTOS}\n";
	print $fix_label .     "DefaultTTL			: $objItem->{DefaultTTL}\n";
	print $fix_label .     "Description			: $objItem->{Description}\n";

	print $fix_label .     "FullDNSRegistrationEnabled	: $objItem->{FullDNSRegistrationEnabled}\n";
	print $fix_label .     "GatewayCostMetric		: " . join(",", (in $objItem->{GatewayCostMetric})) . "\n";
	print $fix_label .     "IGMPLevel			: $objItem->{IGMPLevel}\n";

	print $fix_label .     "IPConnectionMetric		: $objItem->{IPConnectionMetric}\n";
	print $fix_label .     "IPFilterSecurityEnabled		: $objItem->{IPFilterSecurityEnabled}\n";
	print $fix_label .     "IPPortSecurityEnabled		: $objItem->{IPPortSecurityEnabled}\n";
	print $fix_label .     "IPSecPermitIPProtocols		: " . join(",", (in $objItem->{IPSecPermitIPProtocols})) . "\n";
	print $fix_label .     "IPSecPermitTCPPorts		: " . join(",", (in $objItem->{IPSecPermitTCPPorts})) . "\n";
	print $fix_label .     "IPSecPermitUDPPorts		: " . join(",", (in $objItem->{IPSecPermitUDPPorts})) . "\n";
	print $fix_label .     "IPUseZeroBroadcast		: $objItem->{IPUseZeroBroadcast}\n";
	print $fix_label .     "KeepAliveInterval		: $objItem->{KeepAliveInterval}\n";
	print $fix_label .     "KeepAliveTime			: $objItem->{KeepAliveTime}\n";
	print $fix_label .     "MTU				: $objItem->{MTU}\n";
	print $fix_label .     "NumForwardPackets		: $objItem->{NumForwardPackets}\n";
	print $fix_label .     "PMTUBHDetectEnabled		: $objItem->{PMTUBHDetectEnabled}\n";
	print $fix_label .     "PMTUDiscoveryEnabled		: $objItem->{PMTUDiscoveryEnabled}\n";
	print $fix_label .     "ServiceName			: $objItem->{ServiceName}\n";
	print $fix_label .     "SettingID			: $objItem->{SettingID}\n";
	print $fix_label .     "TcpipNetbiosOptions		: $objItem->{TcpipNetbiosOptions}\n";
	print $fix_label .     "TcpMaxConnectRetransmissions	: $objItem->{TcpMaxConnectRetransmissions}\n";
	print $fix_label .     "TcpMaxDataRetransmissions	: $objItem->{TcpMaxDataRetransmissions}\n";
	print $fix_label .     "TcpNumConnections		: $objItem->{TcpNumConnections}\n";
	print $fix_label .     "TcpUseRFC1122UrgentPointer	: $objItem->{TcpUseRFC1122UrgentPointer}\n";
	print $fix_label .     "TcpWindowSize			: $objItem->{TcpWindowSize}\n";

	$lan_index++;
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_NetworkConnection\n";
}

my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_NetworkConnection", "WQL",
			wbemFlagReturnImmediately | wbemFlagForwardOnly);

print "hlp:network:connections::Data from class Win32_NetworkConnection\n";
foreach my $objItem (in $colItems)
{
	my $name = $objItem->{LocalName};
	$name =~ s/://g;			# No colons in the label

	my $fix_label = "fix:network:connections:$objItem->{DisplayType} $name";
	my $var_label = $fix_label;
	$var_label =~ s/^fix:/var:/;

	if ( $objItem->{Persistent} ne "1" )
	{
		$fix_label = $var_label;
	}
	# When connecting to a share, the access mask and username will change. Treat as var.
	print $var_label . "::AccessMask	: $objItem->{AccessMask}\n";
	print $fix_label . "::Comment		: $objItem->{Comment}\n";
	print $var_label . "::ConnectionState	: $objItem->{ConnectionState}\n";
#	print $fix_label . "::ConnectionType	: $objItem->{ConnectionType}\n";
#	print "Description: $objItem->{Description}\n";
	print $fix_label . "::DisplayType	: $objItem->{DisplayType}\n";
#	print $fix_label . "::LocalName		: $objItem->{LocalName}\n";
	print $fix_label . "::Name		: $objItem->{Name}\n";
#	print "Persistent: $objItem->{Persistent}\n";
	print $fix_label . "::ProviderName	: $objItem->{ProviderName}\n";
	print $fix_label . "::RemoteName	: $objItem->{RemoteName}\n";
	print $fix_label . "::RemotePath	: $objItem->{RemotePath}\n";
	print $fix_label . "::ResourceType	: $objItem->{ResourceType}\n";
	print $var_label . "::Status		: $objItem->{Status}\n";
	print $var_label . "::UserName	: $objItem->{UserName}\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_Proxy\n";
}

my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_Proxy", "WQL",
		wbemFlagReturnImmediately | wbemFlagForwardOnly);

foreach my $objItem (in $colItems)
{
	print     "fix:network:proxy::ProxyServer	: $objItem->{ProxyServer}\n";
	print     "fix:network:proxy::ProxyPortNumber	: $objItem->{ProxyPortNumber}\n";
	print     "fix:network:proxy::ServerName	: $objItem->{ServerName}\n";
} 

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_IP4RouteTable\n";
}

my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_IP4RouteTable", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);

print "hlp:network:routes::Data from class Win32_IP4RouteTable\n";
print "var:network:routes::";
printf( "%15s %15s %15s %s\n", "Destination", "Mask", "Gateway", "Metric" );
foreach my $objItem (in $colItems)
{
	print "var:network:routes::";
	printf( "%15s %15s %15s %6d\n", "$objItem->{Destination}", "$objItem->{Mask}", "$objItem->{NextHop}", "$objItem->{Metric1}" );
#	print "Protocol: $objItem->{Protocol}\n";
#	print "Status: $objItem->{Status}\n";
#	print "Type: $objItem->{Type}\n";
#	print "InterfaceIndex: $objItem->{InterfaceIndex}\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "end $PROGNAME \n";
}

exit 0 ;
