# Based on code generated by ScriptoMatic from MicroSoft.

# Perl script to collect system data.
# Copyright (C) 2006-2009 QNH.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Contact information: scc.qnh-infrastructure.nl

# SCC-release:	0.1.1
# file-version:	$Revision: 1.26 $

my $PROGNAME = "$0";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "start $PROGNAME \n";
}

my $tmp_1_file = "scc_0900_1";
my $tmp_2_file = "scc_0900_2";
my $proc_debug_file = "scc_0900_proc";

open TMP,">$tmp_1_file";

use strict;
use Win32::OLE('in');

use constant wbemFlagReturnImmediately => 0x10;
use constant wbemFlagForwardOnly => 0x20;

my $computer = $ENV{ SCC_WMI_COMPUTER };

my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2") or die "$PROGNAME: WMI connection failed.\n";

if ( $ENV{ TRACE } > 0 )
{
        print STDERR "	start retrieving Auto Update from registry\n";
}

# Optional: Change the delimiter to '/' to eliminate all of the extra backslashes 
use Win32::TieRegistry (Delimiter => "/");
my $data = "";
my $base_key = "//$computer/HKEY_LOCAL_MACHINE/Software/Microsoft/Windows/CurrentVersion/WindowsUpdate/Auto Update";

my $data = $Registry->{"$base_key/AUoptions"};
print  "var:system:Auto Update::AUoptions		: $data \n";
if ( $data =~ "2\$" )
{
	print  "var:system:Auto Update::Options			: Notify for download and notify for install\n";
}
if ( $data =~ "3\$" )
{
	print  "var:system:Auto Update::Options			: Auto download and notify for install\n";
}
if ( $data =~ "4\$" )
{
	print  "var:system:Auto Update::Options			: Auto download and schedule the install\n";
}
$data = $Registry->{"$base_key/ConfigVer"};
print  "var:system:Auto Update::ConfigVer		: $data \n";
$data = $Registry->{"$base_key/NextDetectionTime"};
print  "var:system:Auto Update::NextDetectionTime	: $data \n";
$data = $Registry->{"$base_key/ScheduledInstallDate"};
print  "var:system:Auto Update::ScheduledInstallDate	: $data \n";
$data = $Registry->{"$base_key/ResetAU"};
print  "var:system:Auto Update::ResetAU			: $data \n";

$data = $Registry->{"$base_key/Results/Detect/LastSuccessTime"};
print  "var:system:Auto Update::Last success detect	: $data \n";
$data = $Registry->{"$base_key/Results/Download/LastSuccessTime"};
print  "var:system:Auto Update::Last success download	: $data \n";
$data = $Registry->{"$base_key/Results/Install/LastSuccessTime"};
print  "var:system:Auto Update::Last success install	: $data \n";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_SystemDriver\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_SystemDriver", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);

foreach my $objItem (in $colItems)
{
	my $class = "system:SystemDriver:$objItem->{Name}";

	print "fix:$class" .         "::AcceptPause	: $objItem->{AcceptPause}\n";
	print "var:$class" .         "::AcceptStop	: $objItem->{AcceptStop}\n";
	print "fix:$class" .         "::Description	: $objItem->{Description}\n";
	print "fix:$class" .         "::DesktopInteract	: $objItem->{DesktopInteract}\n";
	print "fix:$class" .         "::ErrorControl	: $objItem->{ErrorControl}\n";
	print "fix:$class" .         "::PathName	: $objItem->{PathName}\n";
	print "fix:$class" .         "::ServiceType	: $objItem->{ServiceType}\n";
	print "fix:$class" .         "::StartMode	: $objItem->{StartMode}\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_QuickFixEngineering\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_QuickFixEngineering", "WQL",
                  wbemFlagReturnImmediately | wbemFlagForwardOnly);

print "hlp:system:hotfix::Data from class Win32_QuickFixEngineering\n";
foreach my $objItem (in $colItems)
{
	if ( $objItem->{Description} =~ "^\$" )
	{
		next;
	}

	my $label = ":system:hotfix:" . $objItem->{HotFixID} . "::";

	# Handle multi-line descriptions.
	my @line_l = split( "\n", $objItem->{Description} );
	foreach my $line (@line_l)
	{
		print TMP "fix" . $label . "Description		: $line\n";
	}
	print TMP "fix" . $label . "FixComments		: $objItem->{FixComments}\n";
	print TMP "var" . $label . "InstalledBy		: $objItem->{InstalledBy}\n";
	print TMP "var" . $label . "InstalledOn		: $objItem->{InstalledOn}\n";
	print TMP "fix" . $label . "ServicePackInEffect	: $objItem->{ServicePackInEffect}\n";
}
close TMP;

# We want the hotfixes sorted by name (ignore case).
my $sort_exe = "$ENV{ SCC_BIN }" . "sort";
my @args =	(
			"\"$sort_exe\"",
				"-t", ":",
				"-i",
				"-k", "4",
				"-k", "6",
				"-o", "$tmp_2_file",
				"$tmp_1_file"
		);
if ( system( @args ) )
{
	print STDERR "$PROGNAME: unable to sort hotfix-data: $! \n";
	exit 1;				# Indicate failure.
}

open TMP,"<$tmp_2_file";
while ( <TMP> )
{
	print $_;
}
close TMP;
unlink $tmp_1_file;
unlink $tmp_2_file;

#
# To show the usernames with the processes, we have to link the names of the
# logged on users to the running processes. This achieved by retrieving the
# data of the logged on users (Win32_LoggedOnUser) and the data of the
# processes (Win32_Process) and combining these two datasets by means of
# a coupling (Win32_SessionProcess).
# In detail:
#	Win32_Process.ProcessId		= Win32_SessionProcess.Handle 
#	Win32_SessionProcess.LogonId	= Win32_LoggedOnUser.LogonId
# When the Win32_Process.Handle equals Win32_Process.ProcessId, the username
# is determined by the parent process.

# First we build the hash to hold the names of the logged on users. Index is LogonID.
if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_LoggedOnUser\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_LoggedOnUser", "WQL",
			wbemFlagReturnImmediately | wbemFlagForwardOnly);

# To inspect the details of retrieving the process hierarchy, uncomment all lines
# where file DEBUG is operated.
unlink $proc_debug_file;
#open DEBUG,">$proc_debug_file";

my %UserName = ();
foreach my $objItem (in $colItems)
{
	# Example of Antecedent: \\.\root\cimv2:Win32_Account.Domain="LAPTOPSIEMK",Name="SYSTEM"
	my $name = "$objItem->{Antecedent}";
	$name =~ s/.*Name="//;
	$name =~ s/".*//;
	$name = "\L$name";

	# Example of Dependent : \\.\root\cimv2:Win32_LogonSession.LogonId="999"
	my $id = "$objItem->{Dependent}";
	$id =~ s/.*LogonId="//;
	$id =~ s/".*//;

	$UserName{ $id } = "$name";

#	print DEBUG "Collect UserName: id: $id, UserName: $UserName{ $id } \n";
}

# Second we build the hash to connect the handles with the logonids. Index is Handle.
if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_SessionProcess\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_SessionProcess", "WQL",
				wbemFlagReturnImmediately | wbemFlagForwardOnly);

my %LogonId = ();
foreach my $objItem (in $colItems)
{
	# Example of Antecedent: \\.\root\cimv2:Win32_LogonSession.LogonId="999"
	my $id = "$objItem->{Antecedent}";
	$id =~ s/.*LogonId="//;
	$id =~ s/".*//;

	# Example of Dependent : \\.\root\cimv2:Win32_Process.Handle="1032"
	my $handle = "$objItem->{Dependent}";
	$handle =~ s/.*Handle="//;
	$handle =~ s/".*//;

	$LogonId{ $handle } = "$id";

#	print DEBUG "Collect LogonId: handle: $handle, LogonId: $LogonId{ $handle } \n";
}

# At last we are going to collect the process data. As we want to sort the processes
# into their hierarchy, we calculate their "hierarchy level" and write the data to file
# and sort it to get them in the proper order.
if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_Process\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_Process", "WQL",
			wbemFlagReturnImmediately | wbemFlagForwardOnly);

my $proc_cnt = 0;
my %proc_pid = ();
my %proc_ppid = ();
my %proc_handle = ();
my %proc_thread = ();
my %proc_prio = ();
my %proc_name = ();
my %proc_cmdline = ();
my %proc_index = ();
foreach my $objItem (in $colItems)
{
	my $pid = "$objItem->{ProcessId}";
	my $i = $proc_cnt;
	$proc_pid{ $proc_cnt } = "$pid";
	$proc_ppid{ $i }	= "$objItem->{ParentProcessId}";
	$proc_handle{ $i }	= "$objItem->{Handle}";
	$proc_thread{ $i }	= "$objItem->{ThreadCount}";
	$proc_prio{ $i }	= "$objItem->{Priority}";
	$proc_name{ $i }	= "$objItem->{Name}";
	$proc_cmdline{ $i }	= "$objItem->{CommandLine}";
	$proc_index{ $pid }	= $proc_cnt;
	$proc_cnt += 1;
}

# To determine the level of all processes in the hierarchy, we first determine
# which processes have no parents or have no children.
my $i = 0;
my %has_parent = ();
my %has_child = ();
my %proc_level = ();
for ( $i = 0; $i < $proc_cnt; $i++ )
{
	my $pid = $proc_pid{ $i };

#	print DEBUG "process-data: pid: $pid, ppid: $proc_ppid{ $i }\n";
	if ( $proc_ppid{ $i } ne $pid )
	{
		# This process has a parent. The parent has a child.
		$has_parent{ $i } = 1;
		$has_child{ $proc_index{ $proc_ppid{ $i } } } = 1;
	}
	else
	{
		# This process has no parent and is in top of the hierarchy.
		# Set the level in the hierarchy to 1.
		$has_parent{ $i } = 0;
		$proc_level{ $i } = 1;
	}
}

# Processes having a PPID that does not correspond with an existing process are
# in top of the hierarchy. Set the level in the hierarchy.
for ( $i = 0; $i < $proc_cnt; $i++ )
{
	my $ppid = $proc_ppid{ $i } + 0;
	if ( ( $has_parent{ $i } eq 0 ) || ( ( $proc_index{ $ppid } + 0 ) eq 0 ) )
	{
		if ( $ppid ne 0 )
		{
			$proc_level{ $i } = 1;
		}
	}
}

my $max_level = 1;
# Assign the proper level in the hierarchy to all processes.
for ( $i = 0; $i < $proc_cnt; $i++ )
{
	my $pid = $proc_pid{ $i };

	if ( ( 0 + $has_child{ $i } ) eq 0 )
	{
		# This process has no children and resides at the end of a "branch" in the process tree.
		# We search our way through all parents until we find a process that already has
		# it's level assigned.
		my $j = $i;
		my $level_increase = 0;				# count the levels on our way
		while ( ( $proc_level{ $j } + 0 ) eq 0 )
		{
			$level_increase++;

			$j = $proc_index{ $proc_ppid{ $j } };	# Goto parent.
		}

		my $new_level = $proc_level{ $j } + $level_increase;
		if ( $new_level gt $max_level )
		{
			$max_level = $new_level;
		}

		# Restart at the end of the "branch" and assign the proper level for all parents.
		my $j = $i;
		while ( ( $proc_level{ $j } + 0 ) eq 0 )
		{
			$proc_level{ $j } = $new_level;
			$new_level--;

			$j = $proc_index{ $proc_ppid{ $j } };	# Goto parent.
		}
	}
}

# The hierarchy is determined by all the full list of all parent process id's.
# By looping over the level, we assure that all higher levels are determined first.
my %proc_hierarchy = ();
for ( my $j = 1; $j <= $max_level; $j++ )
{
	for ( $i = 0; $i < $proc_cnt; $i++ )
	{
		if ( $proc_level{ $i } eq $j )
		{
			if ( $j eq 1 )
			{
				$proc_hierarchy{ $i } = sprintf( "%06d", $proc_pid{ $i } );
			}
			else
			{
				$proc_hierarchy{ $i } = sprintf( "%s%06d", $proc_hierarchy{ $proc_index{ $proc_ppid{ $i } } }, $proc_pid{ $i } );
			}
		}
	}
}

# Write the hierarchy, the level and the process ID to file.
# Sort the file on the first field to put all processes in the proper order.
open TMP,">$tmp_1_file";
for ( $i = 0; $i < $proc_cnt; $i++ )
{
	print TMP "$proc_hierarchy{ $i }:$proc_level{ $i }:$proc_pid{ $i }\n";
}
close TMP;
my @args =	(
			"\"$sort_exe\"",
				"-t", ":",
				"-k", "1",
				"-o", "$tmp_2_file",
				"$tmp_1_file"
		);
if ( system( @args ) )
{
	print STDERR "$PROGNAME: unable to sort process-data: $! \n";
	exit 1;				# Indicate failure.
}

my $label = "var:system:process hierarchy::";
printf( "%s%6s %6s %6s %4s %-15s %-25s %-100s\n", $label, "PID", "PPID", "Thread", "Prio", "User", "Name", "Command line" );

print "hlp:system:process hierarchy::Data from class Win32_LoggedOnUser\n";
print "hlp:system:process hierarchy::Data from class Win32_SessionProcess\n";
print "hlp:system:process hierarchy::Data from class Win32_Process\n";
open TMP,"<$tmp_2_file";
while ( <TMP> )
{
	chomp();

	s/^[0-9]*://;		# erase hierarchy

	my $level = $_;
	$level =~ s/:.*//;	# just leave the level

	s/^[0-9]*://;		# erase level
	my $pid = $_;

	my $i = $proc_index{ 0 + $pid };
	
	printf( "%s%6d %6d %6d %4d ", $label, $pid, $proc_ppid{ $i }, $proc_thread{ $i }, $proc_prio{ $i } );
	printf( "%-15s ", $UserName{ $LogonId{ $pid } } );
	for ( ; $level > 1 ; $level-- )
	{
		printf( "  " );
	}
#	print DEBUG "pid: $pid, LogonId: $LogonId{ $pid } \n";
	printf( "%-25.25s %-100s\n", $proc_name{ $i }, $proc_cmdline{ $i } );
}
close TMP;

#close DEBUG;

unlink $tmp_1_file;
unlink $tmp_2_file;

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_Service\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_Service", "WQL",
					wbemFlagReturnImmediately | wbemFlagForwardOnly);

# Print the header of the services.
# Split in survey and detail. Now we produce a survey, details come later.
my $label = "fix:system:services:survey::";
print $label;
printf( "%-30.30s ", "Name" );
printf( "%-10.10s ", "StartMode" );
printf( "%-15.15s ", "Type" );
printf( "%-60.60s\n", "Description" );

# The services can be in different order. Write to file and sort them.
open TMP,">$tmp_1_file";
foreach my $objItem (in $colItems)
{
	printf( TMP "%-30.30s:", $objItem->{Name} );
	printf( TMP "%-10.10s:", $objItem->{StartMode} );
	printf( TMP "%-15.15s:", $objItem->{ServiceType} );
	printf( TMP "%-60.60s\n", $objItem->{DisplayName} );
}
close TMP;

# Sort on name of service, ignore case
my @args =	(
			"\"$sort_exe\"",
				"-t", ":",
				"-k", "1",
				"-o", "$tmp_2_file",
				"$tmp_1_file"
		);
if ( system( @args ) )
{
	print STDERR "$PROGNAME: unable to sort survey of services: $! \n";
	exit 1;				# Indicate failure.
}

open TMP,"<$tmp_2_file";
while ( <TMP> )
{
	print $label;
	s/:/ /g;			# Replace separators used for sorting.
	print $_;			# Including newline (no chomp).
}
close TMP;

unlink $tmp_1_file;
unlink $tmp_2_file;

# Now the survey has been produced, we show the details for each service.
if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_Service\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_Service", "WQL",
					wbemFlagReturnImmediately | wbemFlagForwardOnly);
my $label = "system:services";
foreach my $objItem (in $colItems)
{
	print "fix:$label:$objItem->{Name}::DisplayName	: $objItem->{DisplayName}\n";
	print "fix:$label:$objItem->{Name}::PathName	: $objItem->{PathName}\n";
	print "fix:$label:$objItem->{Name}::ServiceType	: $objItem->{ServiceType}\n";
	print "fix:$label:$objItem->{Name}::StartMode	: $objItem->{StartMode}\n";
	print "var:$label:$objItem->{Name}::AcceptStop	: $objItem->{AcceptStop}\n";
	print "var:$label:$objItem->{Name}::AcceptPause	: $objItem->{AcceptPause}\n";
	print "fix:$label:$objItem->{Name}::ErrorControl	: $objItem->{ErrorControl}\n";
	print "fix:$label:$objItem->{Name}::StartName	: $objItem->{StartName}\n";
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "	start Win32_DependentService\n";
}
my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_DependentService", "WQL",
		wbemFlagReturnImmediately | wbemFlagForwardOnly);

open TMP,">$tmp_1_file";
foreach my $objItem (in $colItems)
{
	# Example of data is:
	# Antecedent: \\XXXXXXXXX\root\cimv2:Win32_Service.Name="RpcSs"
	my $ant = $objItem->{Antecedent};
	my $dep = $objItem->{Dependent};

	if ( $ant =~ /Win32_SystemDriver/ )
	{
		next;			# Skip dependencies with drivers
	}

	$ant =~ s/.*Name="//;
	$ant =~ s/"$//;
	$dep =~ s/.*Name="//;
	$dep =~ s/"$//;

	print TMP "$ant:$dep\n";
}
close TMP;

# Sort on antecedent and dependent, ignore case
my @args =	(
			"\"$sort_exe\"",
				"-t", ":",
				"-k", "1",
				"-k", "2",
				"-o", "$tmp_2_file",
				"$tmp_1_file"
		);
if ( system( @args ) )
{
	print STDERR "$PROGNAME: unable to sort required services: $! \n";
	exit 1;				# Indicate failure.
}

print "hlp:system:services::Data from class Win32_Service\n";
print "hlp:system:services::Data from class Win32_DependentService\n";
open TMP,"<$tmp_2_file";
while ( <TMP> )
{
	chomp();
	my $ant = $_;
	my $dep = $_;

	$ant =~ s/:.*//;
	$dep =~ s/.*://;

	print "fix:system:services:$ant" . "::Required by	: $dep\n";
}
close TMP;

# Sort on dependent and antecedent, ignore case
my @args =	(
			"\"$sort_exe\"",
				"-t", ":",
				"-k", "2",
				"-k", "1",
				"-o", "$tmp_2_file",
				"$tmp_1_file"
		);
if ( system( @args ) )
{
	print STDERR "$PROGNAME: unable to sort requiring services: $! \n";
	exit 1;				# Indicate failure.
}

open TMP,"<$tmp_2_file";
while ( <TMP> )
{
	chomp();
	my $ant = $_;
	my $dep = $_;

	$ant =~ s/:.*//;
	$dep =~ s/.*://;

	print "fix:system:services:$dep" . "::Requires	: $ant\n";
}
close TMP;

# Bill Jacqmein reported that the SecurityCenter class is absent on W2K3.
my $security_center_present = 1;
my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\SecurityCenter") or $security_center_present = 0;
if ( $security_center_present eq 1 )
{
	if ( $ENV{ TRACE } > 0 )
	{
		print STDERR "	start AntiVirusProduct\n";
	}
	my $colItems = $objWMIService->ExecQuery("SELECT * FROM AntiVirusProduct", "WQL",
			wbemFlagReturnImmediately | wbemFlagForwardOnly);

	my $label = "system:SecurityCenter:AntiVirusProduct:";
	foreach my $objItem (in $colItems)
	{
		print       "fix:$label:companyName			: $objItem->{companyName}\n";
		print       "fix:$label:displayName			: $objItem->{displayName}\n";
		print       "fix:$label:enableOnAccessUIMd5Hash		: $objItem->{enableOnAccessUIMd5Hash}\n";
		print       "fix:$label:enableOnAccessUIParameters	: $objItem->{enableOnAccessUIParameters}\n";
		print       "fix:$label:instanceGuid			: $objItem->{instanceGuid}\n";
		print       "fix:$label:onAccessScanningEnabled		: $objItem->{onAccessScanningEnabled}\n";
		print       "fix:$label:pathToEnableOnAccessUI		: $objItem->{pathToEnableOnAccessUI}\n";
		print       "fix:$label:pathToUpdateUI			: $objItem->{pathToUpdateUI}\n";
		print       "fix:$label:productUptoDate			: $objItem->{productUptoDate}\n";
		print       "fix:$label:updateUIMd5Hash			: $objItem->{updateUIMd5Hash}\n";
		print       "fix:$label:updateUIParameters		: $objItem->{updateUIParameters}\n";
		print       "fix:$label:versionNumber			: $objItem->{versionNumber}\n";

	} 

	if ( $ENV{ TRACE } > 0 )
	{
		print STDERR "	start FirewallProduct\n";
	}

	my $colItems = $objWMIService->ExecQuery("SELECT * FROM FireWallProduct", "WQL",
			wbemFlagReturnImmediately | wbemFlagForwardOnly);

	my $label = "system:SecurityCenter:FireWallProduct:";
	foreach my $objItem (in $colItems)
	{
		print      "fix:$label:companyName		: $objItem->{companyName}\n";
		print      "fix:$label:displayName		: $objItem->{displayName}\n";
		print      "fix:$label:enabled			: $objItem->{enabled}\n";
		print      "fix:$label:enableUIParameters	: $objItem->{enableUIParameters}\n";
		print      "fix:$label:PathToEnableUI		: $objItem->{PathToEnableUI}\n";
		print      "fix:$label:versionNumber		: $objItem->{versionNumber}\n";
	} 

}	# if ( $security_center_present eq 1 )

unlink $tmp_1_file;
unlink $tmp_2_file;

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "end $PROGNAME \n";
}

exit 0 ;
