# Based on code generated by ScriptoMatic from MicroSoft.

# Perl script to collect user data.
# Copyright (C) 2007-2009 QNH.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Contact information: scc.qnh-infrastructure.nl

# SCC-release:	0.1.1
# file-version:	$Revision: 1.6 $

my $PROGNAME = "$0";

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "start $PROGNAME \n";
}

use strict;
use Win32::OLE('in');

use constant wbemFlagReturnImmediately => 0x10;
use constant wbemFlagForwardOnly => 0x20;

my $computer = $ENV{ SCC_WMI_COMPUTER };

my $objWMIService = Win32::OLE->GetObject("winmgmts:\\\\$computer\\root\\CIMV2") or die "$PROGNAME: WMI connection failed.\n";

if ( $ENV{ TRACE } > 0 )
{
        print STDERR "  start Win32_UserAccount\n";
}

my %sidtype_list = ();
$sidtype_list{ 1 } = "User";
$sidtype_list{ 2 } = "Group";
$sidtype_list{ 3 } = "Domain";
$sidtype_list{ 4 } = "Alias";
$sidtype_list{ 5 } = "WellKnownGroup";
$sidtype_list{ 6 } = "DeletedAccount";
$sidtype_list{ 7 } = "Invalid";
$sidtype_list{ 8 } = "Unknown";
$sidtype_list{ 9 } = "Computer";

my $query = "SELECT * FROM Win32_UserAccount Where LocalAccount = TRUE";
if ( $ENV{ SCC_OS_VERSION } < 5.1 )
{
        # LocalAccount not available for Win2K: check for tje Domain of the account
        $query = sprintf( "SELECT * FROM Win32_UserAccount Where Domain = '%s'", $computer );
}
my $colItems = $objWMIService->ExecQuery( $query, "WQL", wbemFlagReturnImmediately | wbemFlagForwardOnly);

my %user_name_list = ();
foreach my $objItem ( in $colItems )
{
	$user_name_list{ $objItem->{Name} } = 1;

	my $label = "fix:users:local users:$objItem->{Name}:";

	print 	        "$label:AccountType		: $objItem->{AccountType}\n";
	print           "$label:Description		: $objItem->{Description}\n";
	print           "$label:Disabled		: $objItem->{Disabled}\n";
	print           "$label:Domain			: $objItem->{Domain}\n";
	print           "$label:Lockout			: $objItem->{Lockout}\n";
	print           "$label:PasswordChangeable	: $objItem->{PasswordChangeable}\n";
	print           "$label:PasswordRequired	: $objItem->{PasswordRequired}\n";
	print           "$label:SID			: $objItem->{SID}\n";
	print           "$label:SIDType			: $sidtype_list{ $objItem->{SIDType} }\n";
	print           "$label:Status			: $objItem->{Status}\n";
}

if ( $ENV{ TRACE } > 0 )
{
        print STDERR "  start Win32_Group\n";
}

my $query = "SELECT * FROM Win32_Group Where LocalAccount = TRUE";
if ( $ENV{ SCC_OS_VERSION } < 5.1 )
{
        # LocalAccount not available for Win2K: check for tje Domain of the group
	$query = sprintf( "SELECT * FROM Win32_Group Where Domain = '%s'", $ENV{ SCC_WMI_COMPUTER } );
}
my $colItems = $objWMIService->ExecQuery( $query, "WQL", wbemFlagReturnImmediately | wbemFlagForwardOnly);

my %group_name_list = ();
foreach my $objItem ( in $colItems )
{
	$group_name_list{ $objItem->{Name} } = 1;

	my $label = "fix:users:local groups:$objItem->{Name}:";

	print "$label:Description	: $objItem->{Description}\n";
	print "$label:Domain		: $objItem->{Domain}\n";
	print "$label:SID		: $objItem->{SID}\n";
	print "$label:SIDType		: $sidtype_list{ $objItem->{SIDType} }\n";
	print "$label:Status		: $objItem->{Status}\n";
}

# On large domains, one, single query for all Win32_GroupUser takes too much time and requires too much memory.
# Therefore we query membership per local group.
foreach my $local_group ( keys %group_name_list )
{
	if ( $ENV{ TRACE } > 0 )
	{
		print STDERR "	start Win32_GroupUser for group: $local_group \n";
	}

	# Local groups belong to the "domain" of the computer being queried.
	my $colItems = $objWMIService->ExecQuery("SELECT * FROM Win32_GroupUser where GroupComponent = \"Win32_Group.Domain=\'$computer\',Name=\'$local_group\'\"",
			"WQL", wbemFlagReturnImmediately | wbemFlagForwardOnly); 

	foreach my $objItem ( in $colItems )
	{
		my $group	= $objItem->{GroupComponent};
		$group		=~ s/"$//;
		$group		=~ s/.*"//;
		my $user	= $objItem->{PartComponent};
		$user		=~ s/"$//;
		$user		=~ s/.*"//;

		if ( $user_name_list{ $user }  > 0 ) 
		{
			print "fix:users:local users:$user" . "::Member of		: $group\n";
		}
		if ( $group_name_list{ $group }  > 0 )
		{
			print "fix:users:local groups:$group" . "::Member		: $user\n";
		}
	}
}

if ( $ENV{ TRACE } > 0 )
{
	print STDERR "end $PROGNAME \n";
}

exit 0 ;
